<?php
add_action( 'wp_ajax_wosmpl_upload_file', 'wosmpl_wosmpl_upload_file' );

function wosmpl_reduce_image($file_path,$ext,$width,$height,$new_widths) {
    foreach ($new_widths as $new_width) {
        $new_height = $height * ($new_width/$width);
        if ($ext == 'jpeg') {
            $source = imagecreatefromjpeg($file_path);
        } else if ($ext == 'png') {
            $source = imagecreatefrompng($file_path);
        }
        $thumb = imagecreatetruecolor($new_width, $new_height);
        imagecopyresampled($thumb, $source, 0, 0, 0, 0, $new_width,$new_height, $width, $height);
        $reduced_fn = str_replace('.','-'.$new_width.'.',$file_path);
        if ($ext == 'jpeg') {
            imagejpeg($thumb,$reduced_fn);
        } else if ($ext == 'png') {
            imagepng($thumb,$reduced_fn);
        }
    }
    
}
function wosmpl_wosmpl_upload_file() {
    
    check_ajax_referer( 'wosmpl_ajax', '_ajax_nonce' );
    $return = [];
    $file = $_POST['file'] ;

    if ($file) {
        $base64 = sanitize_text_field($file['base64']);
        $base64 = str_replace('data:'.$file['type'].';base64,', '', $base64);
        list($mtype,$ext) = explode('/', $file['type']);
        $fname = hash('sha1',$file['base64']) . '.' . $ext;
        $file_path = get_option('wosmpl_upload_dir') .'/' .$fname;
        if (file_put_contents($file_path,base64_decode($base64))) {
            $return['file_url'] = str_replace(get_home_path(),'/',$file_path);
            if (strpos($mtype, 'image') !== FALSE) {
                $return['img_info'] = getimagesize($file_path);
                $width = $return['img_info'][0];
                $height = $return['img_info'][1];
                wosmpl_reduce_image($file_path,$ext,$width,$height,[125,350]);
                   
            }

            
        } else {
            $return['error'] = 'File cannot be saved !';
        }
       

        
    }
    wp_send_json($return);
    wp_die(); // all ajax handlers should die when finished
}